import common
import datetime

precisionForAllTags = []
recallForAllTags = []
fscoreForAllTags = []
    
altprecisionForAllTags = []
altrecallForAllTags = []
altfscoreForAllTags = []

def getTruePositive(precision, recall, foundGuessed, foundCorrect):
    truepositive1 = precision*foundGuessed
    truepositive2 = recall*foundCorrect
    print str(truepositive1), str(truepositive2)
    if abs(truepositive1 - truepositive1) > 0.1:
        print "Output from Conll is inconsistent"
        exit(1)
    else:
        return truepositive1

def calculateAndPrintResult(tagsToEvaluate, conllResults, outputfile, timestarted, options, name):
    for tag in tagsToEvaluate:
        outputfile.write("********** " + tag + " **********\n")
        precisionList = []
        recallList = []
        fscoreList = []
        precisionConfList = []
        recallConfList = []
        foundGuessedList = []
        foundCorrectList = []
        truepositiveList  = []
        for dict in conllResults:
            if dict.has_key(tag):
                precision = dict[tag][0]
                recall = dict[tag][1]
                foundGuessed = float(dict[tag][2])
                foundCorrect = float(dict[tag][3])
                truepositive = getTruePositive(precision, recall, foundGuessed, foundCorrect)
                precisionList.append(precision)
                recallList.append(recall)
                fscoreList.append(common.computeFScore(precision, recall))
                precisionConfList.append(common.calculate95Conf(precision, foundGuessed))
                recallConfList.append(common.calculate95Conf(recall, foundCorrect))
                foundGuessedList.append(foundGuessed)
                foundCorrectList.append(foundCorrect)
                truepositiveList.append(truepositive)
        for el, nr, conf in zip(precisionList, range(0, len(precisionList)), precisionConfList):
            outputfile.write("Precision fold nr " + str(nr) + ": " + str(el) + "\n")
            outputfile.write("(95% conf int, precision fold nr " + str(nr) + ": " + str(conf) + ")\n\n")
        outputfile.write("\n")
        for el, nr, conf in zip(recallList, range(0, len(recallList)), recallConfList):
            outputfile.write("Recall fold nr " + str(nr) + ": " + str(el) + "\n")
            outputfile.write("(95% conf int, recall fold nr " + str(nr) + ": " + str(conf) + ")\n\n")
            outputfile.write("\n")
            for el, nr in zip(fscoreList, range(0, len(fscoreList))):
                outputfile.write("Fscore fold nr " + str(nr) + ": " + str(el) + "\n")
            precision = common.computeMeanForNumbersInList(precisionList)
            recall = common.computeMeanForNumbersInList(recallList)
            fscore = common.computeMeanForNumbersInList(fscoreList)

            altprecision = common.computePrecision(sum(truepositiveList), sum(foundGuessedList))
            altprecisionPseudoConf = common.calculate95Conf(altprecision, sum(foundGuessedList))
            altrecall = common.computeRecall(sum(truepositiveList), sum(foundCorrectList))
            altrecallPseudoConf = common.calculate95Conf(altrecall, sum(foundCorrectList))
            altfscore = common.computeFScore(altprecision, altrecall)
            outputfile.write("\n----\n")
            outputfile.write(tag + ": mean altprecision, all folds: " + str(altprecision) + '\n')
            outputfile.write(tag + ": ( 95-conf altprecision, all folds: " + str(altprecisionPseudoConf) + ')\n')
            outputfile.write(tag + ": mean altrecall, all folds: " + str(altrecall) + '\n')
            outputfile.write(tag + ": ( 95-conf altrecall, all folds: " + str(altrecallPseudoConf) + ')\n')
            outputfile.write(tag + ": mean altfscore, all folds: " + str(altfscore) + '\n')

            precisionForAllTags.append(precision)
            recallForAllTags.append(recall)
            fscoreForAllTags.append(fscore)

            altprecisionForAllTags.append(altprecision)
            altrecallForAllTags.append(altrecall)
            altfscoreForAllTags.append(altfscore)

            outputfile.write("\n----\n")
            outputfile.write(tag + ": mean precision, all folds: " + str(precision) + '\n')
            outputfile.write(tag + ": mean recall, all folds: " + str(recall) + '\n')
            outputfile.write(tag + ": mean fscore, all folds: " + str(fscore) + '\n')
            outputfile.write("----\n")
            outputfile.write('\n\n') 

    outputfile.write("************************************** " + '\n')
    outputfile.write("**********All tags ********** " + '\n')
    outputfile.write("************************************** " + '\n')
    meanPrecision = common.computeMeanForNumbersInList(precisionForAllTags)
    meanRecall = common.computeMeanForNumbersInList(recallForAllTags)
    meanFscore = common.computeMeanForNumbersInList(fscoreForAllTags)
    outputfile.write("Mean precision for all tags: " + str(meanPrecision) + '\n')
    outputfile.write("Mean recall for all tags: "  + str(meanRecall) + '\n')
    outputfile.write("Mean fscore for all tags: "  + str(meanFscore) + '\n\n')

    altmeanPrecision = common.computeMeanForNumbersInList(altprecisionForAllTags)
    altmeanRecall = common.computeMeanForNumbersInList(altrecallForAllTags)
    altmeanFscore = common.computeMeanForNumbersInList(altfscoreForAllTags)
    outputfile.write("Mean altprecision for all tags: " + str(altmeanPrecision) + '\n')
    outputfile.write("Mean altrecall for all tags: "  + str(altmeanRecall) + '\n')
    outputfile.write("Mean altfscore for all tags: "  + str(altmeanFscore) + '\n\n')

    timestopped = datetime.datetime.now()
    outputfile.write("Started: " + str(timestarted) +  '\n')
    outputfile.write("Total time: " + str(timestopped - timestarted) +  '\n')

    #outputfile.write("Options: " + options + '\n')
    #features = open(crfFeatures, "r")
    #featureContents = features.read()
    #features.close()
    #outputfile.write('\nUsed features: \n**********************\n')
    #outputfile.write(featureContents + '\n\n') 

    configForSerieFile = open("foldEvaluationConfig/configForSerie.py", "r")
    configForSerie = configForSerieFile.read()
    configForSerieFile.close()
    outputfile.write('\nUsed properties for foldEvaluation in foldEvaluationConfig/configForSerie.py: \n**********************\n')
    outputfile.write(configForSerie + '\n\n')

    configForRunFile = open("foldEvaluationConfig/" + name + "/"+  name + "_config.py", "r")
    configForRun = configForRunFile.read()
    configForRunFile.close()
    outputfile.write("\nUsed properties for foldEvaluation in " + name + "_config.py: \n**********************\n")
    outputfile.write(configForRun + '\n\n')

    outputfile.close()
    return altmeanPrecision, altmeanRecall, altmeanFscore
