import csv
import os
import common


def parse(granskaProcOutput, maltOutputfile, dir, name):
    config = common.getImport(name, name + "_config")
    maltdir = config.maltdir
    
    maltTempOutput = os.path.join(dir, "maltTemp.txt")
    granskaProcOutputFile = open(dir + granskaProcOutput, "r")
    rowReader = csv.reader(granskaProcOutputFile, delimiter='\t', quotechar='|')
    counter = 0
    result = []
    for row in rowReader:
        if row == []:
            counter = 0
            result.append(row)
        else:
            counter = counter + 1
            c5 = row[2].split("/")[0].replace(".","|")
            result.append([counter, row[0], "_", row[1].upper(), row[1].upper(), c5.upper()])
            
    outfile  = dir + maltOutputfile
    out = open(outfile, "w")
    c = csv.writer(out, delimiter='\t')
    for line in result:
        c.writerow(line)
    granskaProcOutputFile.close()
    out.close()
    savedPath = os.getcwd()
    os.chdir(maltdir)
    command = "java -jar -Xmx1000m malt.jar -c swemalt -i " + os.path.join(savedPath, outfile) + " -o " + os.path.join(savedPath, maltTempOutput) + " -m parse"
    print "Running maltparser: " + command
    os.system(command)
    os.chdir(savedPath)

    out = open(maltTempOutput, "r")
    rowReader = csv.reader(out, delimiter='\t')
    maltRows = []
    maxlen = 0
    for row in rowReader:
        maltRows.append(row)
        if len(row) > maxlen:
            maxlen = len(row)
    out.close()
    #print maxlen
    
    newFileContent = []
    granskaProcOutputFile = open(dir + granskaProcOutput, "r")
    rowReader = csv.reader(granskaProcOutputFile, delimiter='\t')
    for row, malt in zip(rowReader, maltRows):
        if row == [] and malt == []:
            newFileContent.append(row)
        else:
            newrow = row[0:-1]
            newrow.extend(malt[6:maxlen-1])
            newrow.append(row[-1])
            #print row, row[0:-1], malt[6:maxlen-1], row[-1]
            newFileContent.append(newrow)
    granskaProcOutputFile.close()
    
    granskaProcOutputFile = open(dir + granskaProcOutput, "w")
    c = csv.writer(granskaProcOutputFile, delimiter='\t')
    for line in newFileContent:
        c.writerow(line)
