import foldEvaluationConfig.configForSerie

NOTAG = "O"

import sys
sys.path.append("./foldEvaluationConfig")

snomedpath = foldEvaluationConfig.configForSerie.terminologyPath

def getWords(featureList):
    words = []
    for line in featureList:
        words.append(line[0])
    return words

def findTermInSequence(wordList, termDict):
    #print wordList
    nrOfWords = len(wordList)
    #print nrOfWords, wordList
    if nrOfWords < 1:
        return []
    for searchedTermLength in range(nrOfWords, 0, -1):
        found = findTermInSequenceWithLength(searchedTermLength, wordList, termDict)
        if found:
            return found
    #print "inget hittat", wordList
    nothingFoundList = []
    for el in wordList:
        nothingFoundList.append((el, NOTAG)) 
    return nothingFoundList

def findTermInSequenceWithLength(searchedTermLength, wordList, termDict):
    for index in range(0, len(wordList) - searchedTermLength + 1):
        wordstr = " ".join(wordList[index:index + searchedTermLength])
        if termDict.has_key(wordstr.lower()):
            snomedNumber = termDict[wordstr.lower()]
            before = wordList[0: index]
            after = wordList[index + searchedTermLength:len(wordList)]
            afterresult = findTermInSequence(after, termDict)
            beforeresult = findTermInSequence(before, termDict)
            currentresult = []
            for el in wordList[index:index + searchedTermLength]:
                currentresult.append((el, snomedNumber))
            resultList = beforeresult + currentresult + afterresult
            return resultList
    #print "inget hittat length", wordList
    return 0 #nothing found                   

patientRecordText = open("testfilstort2b.txt", "r")
splitted = [el.strip().split(".") for el in patientRecordText.readlines()]
print "1"
splitted = [el2.strip() + " ." for el in splitted for el2 in el]
print "2"
patientRecordText.close()

TAG1 = "Clinical_Finding"
TAG2 = "Body_part"

termDict = {}
terms = open(snomedpath + "disorder.withoutcommon.txt")
for line in terms:
    termDict[line.strip()] = TAG1
terms2 = open(snomedpath + "finding.withoutcommon.txt")
for line in terms2:
    termDict[line.strip()] = TAG1
terms3 = open(snomedpath + "body_structure.withoutstopwords.txt")
for line in terms3:
    termDict[line.strip()] = TAG2
terms4 = open(snomedpath + "body_structure.all.txt")
for line in terms4:
    termDict[line.strip()] = TAG2

print "2b"

featureFile = open("featurefile_additionaldata.txt", "w")

nrOfNonDisorderSentences = 0
resultList = []
for sentence in splitted:
    taggedResult = None
    sentence = sentence.replace('"', '').replace(",", " ,")
    result = findTermInSequence(sentence.split(' '), termDict)
    if TAG1 in [tag for (word, tag) in result] or TAG2 in [tag for (word, tag) in result]:
        resultStr = ""
        previousTag = NOTAG
        for word, tag in result:
            #print word, tag
            if tag == previousTag:
                resultStr = resultStr + word + " "
            elif tag != previousTag and tag == NOTAG:
                resultStr = resultStr.strip() + "</" + previousTag + ">"+ " " + word + " "
            elif tag != previousTag and tag != NOTAG and previousTag != NOTAG:
                 resultStr = resultStr.strip() + "</" + previousTag + ">"+ "<" + tag + ">" + word + " "
            elif tag != previousTag and tag != NOTAG and previousTag == NOTAG:
                 resultStr = resultStr + "<" + tag + ">" + word + " "
            else:
                print ("Unexpected combo: tag=" + tag + ". previousTag= "  + previousTag)
            previousTag = tag
        featureFile.write(resultStr)
print "3"

featureFile.close()
