import csv
import os
import common
import runCRFProperties

TOPNR = 5


def addWord(word, label, termDict):    
    if  not termDict.has_key(label):
        termDict[label] = {}
    common.addBag(word, termDict[label])

def evaluateTag(rows, termDict):
    i = 0
    foundWord = ""
    currentLabel = "" 
    while i < len(rows):
        row = rows[i]
        word = row[0]
        #gold = row[1]
        estimated = row[2]
        if estimated.startswith("B-"):
            foundWord = word
            currentLabel = estimated.replace("B-", "")
            #print "should be b", word, estimated
            i = i + 1
            if i < len(rows):
                row = rows[i]
                word = row[0]
                estimated = row[2]
                while estimated.startswith("I-") and i < len(rows):
                    #print"should be i", word, estimated
                    foundWord = foundWord + " " + word
                    i = i + 1
                    row = rows[i]
                    word = row[0]
                    estimated = row[2]
            else:
                print foundWord
            
            addWord(foundWord.strip().lower(), currentLabel, termDict)
            foundWord = ""
            currentLabel = ""
        else:
            if estimated == "O":
                addWord(word.lower(), estimated, termDict)
            else:
                print "fel", word, estimated
            i = i + 1
    return termDict      
   
   
def evaluatefile(outputfile, termDict):  
     
    print "Reading information from: " + outputfile
    file = open(outputfile)
    resultReader = csv.reader(file, delimiter='\t', quotechar='|')
    rows = []
    firstRow = 1
    for row in resultReader:
        if row != []:
            numberOfColumns = len(row)
       
            estimated = row[numberOfColumns-1]
            gold = row[numberOfColumns-2]
            word = row[0]

            resultRow =  [word, gold, estimated]
            rows.append(resultRow)
        
    file.close()
    evaluateTag(rows, termDict)


def evaluateDir(dirToEvaluate, resultFile):
    termDict = {}
    outputfeaturefile = "features_rulebased_replaced.txt"
    resultToWrite = open(resultFile, "w")
    resultToWriteNoMatch = open(resultFile + ".nomatch", "w")
    resultToWriteTop = open(resultFile + ".top", "w")
    currentOutput = resultToWrite
    files = [outputfeaturefile]
    for file in files:
        evaluatefile(dirToEvaluate + "/" + file, termDict)
    for key, value in termDict.items():
        if key == "O":
             currentOutput = resultToWriteNoMatch
        else:
            currentOutput.write(common.getUTFCodedWord( u"\n" + key))
            currentOutput.write("\n*************\n")
        resultToWriteTop.write(common.getUTFCodedWord( u"\n" + key))
        resultToWriteTop.write("\n*************\n")
        lst = zip(value.values(), value.keys())  #Ska ge samma ordning enligt dokumentationen
        lst.sort(reverse=True)
        nrOfWritten = 0
        for el in lst:
            currentOutput.write(str(el[0]) + "\t" + el[1] + "\n")
            if nrOfWritten < TOPNR:
                resultToWriteTop.write(str(el[0]) + "\t" + el[1] + "\n")
            nrOfWritten = nrOfWritten + 1
        currentOutput = resultToWrite
    resultToWrite.close()
    resultToWriteNoMatch.close()
    resultToWriteTop.close()
evaluateDir("resultsFromAll/count", "resultsFromAll/count/statistics.txt")
