#########################################
# General properties, common to all runs

#how many times to do cross-validation. Typically, 10
n_fold_n = 2

#the tags to use in the evaluation
tagsToEvaluate = ['finding', 'disorder', "Body_part"]

# True if a new split always shall be generated, False if it shall only be generated if there is no current split. 
generateNewSplitIfThereAlreadyIsOne = False

#the folder containing the files with the corpus text
datafolder = "testdata_rulebased"

# The path to granska. Ending with a /
granskaPath = "/Users/mariaskeppstedt/granska-tagger/"

# The path to where the terminology-files are. Ending with a /
#terminologyPath = "./"
terminologyPath = "/Users/mariaskeppstedt/snomed/versionhanteradkod/genereradeListor/"

#description
serieDescription = "En testserie"

# Tag to indicate that no entity is matched
NOMATCH = "O"

###############################
# What to run
#only use letters a-z, 0-9 and no white space
serieToRun = ["ruleBased"]

tagsToChange = {"finding.all": "Finding", "disorder.all": "Diagnosis_proper", "body_structure.all": "Body_part", \
                    "disorder.all_finding.all":"Diagnosis_proper", "body_structure.all_finding.all": "Body_part", \
                    "finding.all_body_structure.all": "Body_part", "body_structure.all_disorder.all": "Body_part", \
                    "disorder.all_body_structure.all": "Body_part", \
                    "finding.withoutstopwords": "Finding", "disorder.withoutstopwords": "Diagnosis_proper", "body_structure.withoutstopwords": "Body_part", \
                    "disorder.withoutstopwords_finding.withoutstopwords":"Diagnosis_proper", "body_structure.withoutstopwords_finding.withoutstopwords": "Body_part", \
                    "finding.withoutstopwords_body_structure.withoutstopwords": "Body_part", "body_structure.withoutstopwords_disorder.withoutstopwords": "Body_part", \
                    "disorder.withoutstopwords_body_structure.withoutstopwords": "Body_part", \
                    "body_structure.all_disorder.withoutstopwords": "Body_part", \
                    "disorder.all_disorder.withoutstopwords": "Diagnosis_proper", \
                    "disorder.all_finding.withoutstopwords" : "Diagnosis_proper", \
                    "finding.all_finding.withoutstopwords" : "Finding", \
                    "finding.withoutstopwords_disorder.withoutstopwords_body_structure.withoutstopwords" : "Body_part", \
                    "body_structure.all_body_structure.withoutstopwords" : "Body_part", \
                    "disorder.withoutcommon": "Diagnosis_proper", \
                    "finding.withoutcommon" : "Finding",\
                    "body_structure.withoutcommon" : "Body_part", \
                    "disorder.withoutcommon_finding.withoutcommon" : "Diagnosis_proper",\
                    "body_structure.all_qualifier_value.all": "O",\
                    "disorder.all_qualifier_value.all" : "Diagnosis_proper" , \
                    "finding.all_qualifier_value.all" : "O" , \
                    "qualifier_value.all" : "O", \
                    "body_structure.all_body_structure.withoutstopwords_qualifier_value.all": "O", \
                    "disorder.withoutstopwords_body_structure.withoutstopwords_qualifier_value.all": "O", \
                    "finding.all_finding.withoutstopwords_qualifier_value.all" : "O", \
                    "body_structure.withoutstopwords_qualifier_value.all" : "O", \
                    "body_structure.withoutstopwords_person.all" : "O", \
                    "person.all" : "O", \
                    "disorder.all_body_structure.withoutstopwords" : "Body_part", \
                    "disorder.all_body_structure.withoutstopwords_qualifier_value.all" : "O", \
                    "disorder.all_disorder.all_finding.all" : "Diagnosis_proper", \
                    "disorder.all_disorder.all_qualifier_value.all" : "Diagnosis_proper", \
                    "finding.all_body_structure.withoutstopwords" : "Body_part", \
                    "finding.all_body_structure.withoutstopwords_person.all:" : "O", \
                    "qualifier_value.all_body_structure.all_body_structure.withoutstopwords_qualifier_value.all" : "O", \
                    "qualifier_value.all_body_structure.withoutstopwords" : "O", \
                    "qualifier_value.all_finding.all" : "O", \
                    "qualifier_value.all_qualifier_value.all_body_structure.all_body_structure.withoutstopwords_qualifier_value.all" : "O", \
                    "finding.all_body_structure.withoutstopwords_person.all" : "O", \
                    "qualifier_value.all_body_structure.all_qualifier_value.all" : "O", \
                    "qualifier_value.all_qualifier_value.all_body_structure.all_qualifier_value.all" : "O", \
                    "body_structure.all_disorder.withoutstopwords_body_structure.withoutstopwords" : "Body_part", \
                    "disorder.all_body_structure.withoutstopwords_finding.withoutstopwords_body_structure.withoutstopwords" : "Body_part", \
                    "disorder.all_disorder.all_finding.withoutstopwords" : "Diagnosis_proper", \
                    "disorder.all_disorder.withoutstopwords_body_structure.withoutstopwords: " :"Body_part" , \
                    "disorder.all_disorder.withoutstopwords_body_structure.withoutstopwords_qualifier_value.all" : "O", \
                    "disorder.all_disorder.withoutstopwords_disorder.all_finding.all" : "Diagnosis_proper", \
                    "disorder.all_disorder.withoutstopwords_qualifier_value.all" : "Diagnosis_proper", \
                    "finding.all_disorder.withoutstopwords_body_structure.withoutstopwords" : "Body_part" , \
                    "finding.all_finding.all_finding.withoutstopwords" : "Finding" , \
                    "finding.all_finding.withoutstopwords_body_structure.withoutstopwords" : "Body_part" , \
                    "finding.all_finding.withoutstopwords_disorder.withoutstopwords_body_structure.withoutstopwords" : "Body_part" , \
                    "qualifier_value.all_finding.withoutstopwords" : "O" , \
                    "qualifier_value.all_finding.withoutstopwords_body_structure.withoutstopwords" : "O", \
                    "qualifier_value.all_qualifier_value.all_finding.withoutstopwords" : "O", \
                    "disorder.all_disorder.withoutstopwords_body_structure.withoutstopwords" : "O", \
                    "finding.all_person.all" : "0" \
                    }
