# -*- coding: utf-8 -*-

import os
import time
import datetime
import splitFile
import commands
import runCRFProperties
import common
import generateFeatures
import processConllOutput
import glob
import foldEvaluationConfig.configForSerie
import math

#Todo inte kollat att xml:n är välformad. Funkar inte annars

resultsAllRuns = runCRFProperties.resultsAllRuns
outputFromSplitFile = runCRFProperties.outputFromSplitFile
resultsFolder =  runCRFProperties.resultsFolder
crfOutputFolder =  runCRFProperties.crfOutputFolder
latin1codedfile =  runCRFProperties.latin1codedfile
folderForSplittedData =  runCRFProperties.folderForSplittedData
trainFileName =  runCRFProperties.trainFileName
testFileName =  runCRFProperties.testFileName
crfoutputfile = runCRFProperties.crfoutputfile
n_fold_n =  foldEvaluationConfig.configForSerie.n_fold_n
tagsToEvaluate =  foldEvaluationConfig.configForSerie.tagsToEvaluate
generateNewSplitIfThereAlreadyIsOne = foldEvaluationConfig.configForSerie.generateNewSplitIfThereAlreadyIsOne
datafolder = foldEvaluationConfig.configForSerie.datafolder

import sys
sys.path.append("./foldEvaluationConfig")


def getOptionString(config):
    optionstring = ""
    if config.a_option:
        optionstring = optionstring + "-a " + config.a_option + " "
    if config.c_option:
        optionstring = optionstring + "-c " + str(config.c_option) + " "
    if config.f_option:
        optionstring = optionstring + "-f " + str(config.f_option) + " "
    if config.p_option:
        optionstring = optionstring + "-p " + str(config.p_option) + " "
    if config.h_option:
        optionstring = optionstring + "-H " + str(config.h_option) + " "
    return optionstring

def runCRF(name):
    name = name.replace(" ", "_")

    #check that all configuration files for run are there
    common.raiseExceptionIfResourceDoesNotExist("./foldEvaluationConfig/" + name)
    common.raiseExceptionIfResourceDoesNotExist("./foldEvaluationConfig/" + name + "/__init__.py")
    common.raiseExceptionIfResourceDoesNotExist("./foldEvaluationConfig/" + name + "/" + name + "_config.py")
    common.raiseExceptionIfResourceDoesNotExist("./foldEvaluationConfig/" + name + "/" + name + "_template")


    config = common.getImport(name, name + "_config")
    options = getOptionString(config)

    crfFeatures =  "foldEvaluationConfig/" + name + "/" + name + "_template"
    outputForRun = resultsAllRuns + "/" + name
    outputForSplit = resultsAllRuns + "/" + outputFromSplitFile
    timestarted = datetime.datetime.now()
    
    if os.path.exists(outputForRun):
        answer = raw_input("This script will remove the existing files in the directory " + outputForRun + \
                           ". Do you really want to proceed? In that case, press: y followed by enter. ")

        if answer != 'y':
            print "terminating script"
            sys.exit(1)
    print "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n"
    print "*****************************************************"
    print "*****************************************************"
    print "*****************************************************"
    print "Starting " + str(n_fold_n) + "-fold evaluation of folder: " + datafolder
    print "Starting " + str(timestarted)
    print "*****************************************************"
    print "*****************************************************"
    print "*****************************************************"

    
    #Contains the result for these, for all tags
    conllResults = []

    common.ensure_dir(resultsAllRuns)
    common.ensure_dir(outputForRun)
    common.ensure_dir(outputForRun + "/" + crfOutputFolder)
    common.ensure_dir(outputForRun + "/" + resultsFolder)
    common.ensure_dir(outputForRun + "/" + folderForSplittedData)
    

    # only if no folderForSplittedData exists or generateNewSplitIfThereAlreadyIsOne = true, compute a new split for the data. 
    if generateNewSplitIfThereAlreadyIsOne or not os.path.exists(outputForSplit):
        common.ensure_dir(outputForSplit)
        splitFile.splitFilesInDir(datafolder, outputForSplit, n_fold_n, "onlySplitted_" + trainFileName, "onlySplitted_" + testFileName)
    files = glob.glob(outputForSplit + "/onlySplitted_*")
    print "*****************************************"
    for filename in files:
        featurefilename = filename.split("/")[-1].replace("onlySplitted_", "")
        print "************** " + featurefilename + "************** " + filename
        generateFeatures.generateFeatures(filename, outputForRun + "/" + folderForSplittedData + "/" + featurefilename, name, combineCategories = True, reversed = False)
    if config.useAdditionalFile:
        for fold in range(1, n_fold_n + 1):
            print config.useAdditionalFile
            trainfilepath = outputForRun + "/" + folderForSplittedData  + "/" + trainFileName + "_" + str(fold) + ".data"
        
            orignialtrainFile = open(trainfilepath, "r")
            orignialtrainContent = orignialtrainFile.read()
            orignialtrainFile.close()
            
            newtrainFile =  open(trainfilepath, "w")
            for i in range(0, config.nrOfDup):
                newtrainFile.write(orignialtrainContent)
           
            addFile = open(config.additionalFile, "r")
            addFileContent = addFile.read()
            addFile.close()
            newtrainFile.write(addFileContent)
            newtrainFile.close()
        #generateFeatures.generateFeatures(datafile, featuresOutput, combineCategories = True, reversed = False)
        #print "Creates new folds"
        #splitFile.splitFile(featuresOutput, outputForRun + "/" + folderForSplittedData, n_fold_n, trainFileName, testFileName)
  
    outputfile = open(outputForRun + "/" + resultsFolder + "/" + crfoutputfile, "w")
    outputfile.write("Output training\n----------------\n")
    for fold in range(1, n_fold_n + 1):
        common.ensure_file(outputForRun + "/" + crfOutputFolder + "/model")
        os.remove(outputForRun + "/" + crfOutputFolder + "/model")
        common.ensure_file(outputForRun + "/" + crfOutputFolder + "/model")
        trainfilepath = outputForRun + "/" + folderForSplittedData  + "/" + trainFileName + "_" + str(fold) + ".data" 
        testfilepath = outputForRun + "/" + folderForSplittedData + "/" + testFileName + "_" + str(fold)  + ".data"
        testoutputfilepath = outputForRun + "/" + crfOutputFolder +  "/" + testFileName  + "_" + str(fold)  + ".output"
        conloutput = outputForRun + "/" + resultsFolder + "/" + "conl_" +  str(fold)
        outputFromCrf = outputForRun + "/" + crfOutputFolder
        conllResults.append(trainAndTestOneFoldConll(trainfilepath, testfilepath, testoutputfilepath, \
                                outputFromCrf, tagsToEvaluate, crfFeatures, options, outputfile, conloutput))
        
    outputfile.write("\n\n\n\n")

    outputfile.write("***************************************************************\n")
    outputfile.write("***************************************************************\n")
    outputfile.write("********             OUTPUT OF EVALUATION                    **\n")
    outputfile.write("***************************************************************\n")
    outputfile.write("***********************************************************\n\n\n")
    outputfile.write("Name of run:" + name + "\n\n")

    outputfile.write('\n Results when evaluating with conll-script: \n**********************\n')
    precisionForAllTags = []
    recallForAllTags = []
    fscoreForAllTags = []
    
    altprecisionForAllTags = []
    altrecallForAllTags = []
    altfscoreForAllTags = []

    for tag in tagsToEvaluate:
        outputfile.write("********** " + tag + " **********\n")
        precisionList = []
        recallList = []
        fscoreList = []
        precisionConfList = []
        recallConfList = []
        foundGuessedList = []
        foundCorrectList = []
        truepositiveList  = []
        for dict in conllResults:
            if dict.has_key(tag):
                precision = dict[tag][0]
                recall = dict[tag][1]
                foundGuessed = float(dict[tag][2])
                foundCorrect = float(dict[tag][3])
                truepositive = getTruePositive(precision, recall, foundGuessed, foundCorrect)
                precisionList.append(precision)
                recallList.append(recall)
                fscoreList.append(common.computeFScore(precision, recall))
                precisionConfList.append(common.calculate95Conf(precision, foundGuessed))
                recallConfList.append(common.calculate95Conf(recall, foundCorrect))
                foundGuessedList.append(foundGuessed)
                foundCorrectList.append(foundCorrect)
                truepositiveList.append(truepositive)
        for el, nr, conf in zip(precisionList, range(0, len(precisionList)), precisionConfList):
            outputfile.write("Precision fold nr " + str(nr) + ": " + str(el) + "\n")
            outputfile.write("(95% conf int, precision fold nr " + str(nr) + ": " + str(conf) + ")\n\n")
        outputfile.write("\n")
        for el, nr, conf in zip(recallList, range(0, len(recallList)), recallConfList):
            outputfile.write("Recall fold nr " + str(nr) + ": " + str(el) + "\n")
            outputfile.write("(95% conf int, recall fold nr " + str(nr) + ": " + str(conf) + ")\n\n")
        outputfile.write("\n")
        for el, nr in zip(fscoreList, range(0, len(fscoreList))):
            outputfile.write("Fscore fold nr " + str(nr) + ": " + str(el) + "\n")
        precision = common.computeMeanForNumbersInList(precisionList)
        recall = common.computeMeanForNumbersInList(recallList)
        fscore = common.computeMeanForNumbersInList(fscoreList)

        altprecision = common.computePrecision(sum(truepositiveList), sum(foundGuessedList))
        altprecisionPseudoConf = common.calculate95Conf(altprecision, sum(foundGuessedList))
        altrecall = common.computeRecall(sum(truepositiveList), sum(foundCorrectList))
        altrecallPseudoConf = common.calculate95Conf(altrecall, sum(foundCorrectList))
        altfscore = common.computeFScore(altprecision, altrecall)
        outputfile.write("\n----\n")
        outputfile.write(tag + ": mean altprecision, all folds: " + str(altprecision) + '\n')
        outputfile.write(tag + ": ( 95-conf altprecision, all folds: " + str(altprecisionPseudoConf) + ')\n')
        outputfile.write(tag + ": mean altrecall, all folds: " + str(altrecall) + '\n')
        outputfile.write(tag + ": ( 95-conf altrecall, all folds: " + str(altrecallPseudoConf) + ')\n')
        outputfile.write(tag + ": mean altfscore, all folds: " + str(altfscore) + '\n')

        precisionForAllTags.append(precision)
        recallForAllTags.append(recall)
        fscoreForAllTags.append(fscore)

        altprecisionForAllTags.append(altprecision)
        altrecallForAllTags.append(altrecall)
        altfscoreForAllTags.append(altfscore)

        outputfile.write("\n----\n")
        outputfile.write(tag + ": mean precision, all folds: " + str(precision) + '\n')
        outputfile.write(tag + ": mean recall, all folds: " + str(recall) + '\n')
        outputfile.write(tag + ": mean fscore, all folds: " + str(fscore) + '\n')
        outputfile.write("----\n")
        outputfile.write('\n\n') 
    
    outputfile.write("************************************** " + '\n')
    outputfile.write("**********All tags ********** " + '\n')
    outputfile.write("************************************** " + '\n')
    meanPrecision = common.computeMeanForNumbersInList(precisionForAllTags)
    meanRecall = common.computeMeanForNumbersInList(recallForAllTags)
    meanFscore = common.computeMeanForNumbersInList(fscoreForAllTags)
    outputfile.write("Mean precision for all tags: " + str(meanPrecision) + '\n')
    outputfile.write("Mean recall for all tags: "  + str(meanRecall) + '\n')
    outputfile.write("Mean fscore for all tags: "  + str(meanFscore) + '\n\n')

    altmeanPrecision = common.computeMeanForNumbersInList(altprecisionForAllTags)
    altmeanRecall = common.computeMeanForNumbersInList(altrecallForAllTags)
    altmeanFscore = common.computeMeanForNumbersInList(altfscoreForAllTags)
    outputfile.write("Mean altprecision for all tags: " + str(altmeanPrecision) + '\n')
    outputfile.write("Mean altrecall for all tags: "  + str(altmeanRecall) + '\n')
    outputfile.write("Mean altfscore for all tags: "  + str(altmeanFscore) + '\n\n')
    
    timestopped = datetime.datetime.now()
    outputfile.write("Started: " + str(timestarted) +  '\n')
    outputfile.write("Total time: " + str(timestopped - timestarted) +  '\n')

    outputfile.write("Options: " + options + '\n')
    features = open(crfFeatures, "r")
    featureContents = features.read()
    features.close()
    outputfile.write('\nUsed features: \n**********************\n')
    outputfile.write(featureContents + '\n\n') 

    configForSerieFile = open("foldEvaluationConfig/configForSerie.py", "r")
    configForSerie = configForSerieFile.read()
    configForSerieFile.close()
    outputfile.write('\nUsed properties for foldEvaluation in foldEvaluationConfig/configForSerie.py: \n**********************\n')
    outputfile.write(configForSerie + '\n\n')
   
    configForRunFile = open("foldEvaluationConfig/" + name + "/"+  name + "_config.py", "r")
    configForRun = configForRunFile.read()
    configForRunFile.close()
    outputfile.write("\nUsed properties for foldEvaluation in " + name + "_config.py: \n**********************\n")
    outputfile.write(configForRun + '\n\n')

    outputfile.close()
    return altmeanPrecision, altmeanRecall, altmeanFscore

    
def trainAndTestOneFoldConll(trainfilepath, testfilepath, testoutputfilepath, crfOutputFolder, tagsToEvaluate, featureFile, options, outputfile, conloutput):
    doTrainAndTestOneFold(trainfilepath, testfilepath, testoutputfilepath, crfOutputFolder, tagsToEvaluate, featureFile, options, outputfile)
    conllout = processConllOutput.askConllScript(testoutputfilepath, conloutput)
    return conllout

def doTrainAndTestOneFold(trainfilepath, testfilepath, testoutputfilepath, crfOutputFolder, tagsToEvaluate, featureFile, options, outputfile):
    trainCommand = "../../crf_learn " + options + " "+ featureFile + " " + trainfilepath + " " + crfOutputFolder + "/model"
    print "\n\n"
    print "Running command " + trainCommand
    outputfile.write("Running command " + trainCommand + '\n')
    result = commands.getoutput(trainCommand)
    printOutputFromTraining(result, outputfile)

    testCommand = "../../crf_test -m "  + crfOutputFolder + "/model " + testfilepath
    print "Running command " + testCommand
    outputfile.write("Running command " + testCommand + '\n')
    testresults =  commands.getoutput(testCommand)
    formatedTestresults = testresults.replace('\r', '')
    rows = formatedTestresults.split('\n')
    f = open(testoutputfilepath, "w")
    for row in rows:
        f.write(row + os.linesep) 
    #f.write(formatedTestresults)
    f.close()
    
    print "Result test: " + str(result)

    print "*********"
    print testoutputfilepath

def printOutputFromTraining(result, outputfile):
    print "Result training: " + str(result)
    outputfile.write("Result training: ")
    lines = result.split('\n')
    for line in lines:
        if not line.startswith("iter"):
            outputfile.write(line + '\n')
    outputfile.write('\n')


def getTruePositive(precision, recall, foundGuessed, foundCorrect):
    truepositive1 = precision*foundGuessed
    truepositive2 = recall*foundCorrect
    print str(truepositive1), str(truepositive2)
    if abs(truepositive1 - truepositive1) > 0.1:
        print "Output from Conll is inconsistent"
        exit(1)
    else:
        return truepositive1

#runCRF("initial test")
