import csv
import math
import os
import random
import runCRFProperties
import common
import glob


def writeRow(openFile, row):
    toWrite = ""
    for el in row:
        toWrite = toWrite  + '\t' + el
    openFile.write(toWrite.strip() + '\n')
        
def splitFile(filepath, outputdir, nrOfSplits, trainFileName, testFileName):
    print outputdir
    common.ensure_dir(outputdir)
    rowReader = csv.reader(open(filepath), delimiter='\t', quotechar='|')
    rowList = []
    rows = []
    nrOfSentences = 0
    nrOfSentencesInChunk = 0
    for row in rowReader:
        rows.append(row)
        try:
            if row == []:
                nrOfSentences = nrOfSentences + 1
                nrOfSentencesInChunk = nrOfSentencesInChunk + 1
                if nrOfSentencesInChunk >= runCRFProperties.sentencesPerChunk:
                    rowList.append(rows)
                    rows = []
                    nrOfSentencesInChunk = 0
        except:
            print "Strange row: " + str(row)
          
    random.shuffle(rowList)
    sentencesPerPartion = math.ceil(float(len(rowList))/nrOfSplits)
    print "Total number of sentences " + str(nrOfSentences)
    print "Sentences per partion  " + str(sentencesPerPartion) + " in " + str(nrOfSplits) + " partitions."
    for foldNumber in range(0, nrOfSplits):
        trainFile = open(outputdir + "/" + trainFileName + "_" + str(foldNumber) + ".data", 'wb')
        testFile = open(outputdir + "/" + testFileName + "_"  + str(foldNumber) + ".data", 'wb')
        

        partitionCounter = 0
        sentenceCounter = 0
        for sentence in rowList:
            if partitionCounter == foldNumber:
                for row in sentence:
                    writeRow(testFile, row)
                writeRow(testFile, [])
            else:
                for row in sentence:
                    writeRow(trainFile, row)
                writeRow(trainFile, [])
            sentenceCounter = sentenceCounter + 1
            if sentenceCounter >= sentencesPerPartion:
                partitionCounter = partitionCounter + 1
                sentenceCounter = 0
    #for row in rowList:
     #   print row

def splitFilesInDir(dirpath, outputdir, nrOfSplits, trainFileName, testFileName):
    common.ensure_dir(outputdir)
    documentList = []
    nrOfDocuments = 0
    files = glob.glob(dirpath + "/*")
    for filename in files:
        nrOfDocuments = nrOfDocuments + 1
        currentFile = open(filename, "r")
        text = currentFile.read()
        currentFile.close()
        documentList.append(text)
    random.shuffle(documentList)
    documentsPerPartion = math.ceil(float(len(documentList))/nrOfSplits)
    print "Total number of documents " + str(nrOfDocuments)
    print "Documents per partion  " + str(documentsPerPartion) + " in " + str(nrOfSplits) + " partitions."
    for foldNumber in range(1, nrOfSplits + 1):
        trainFile = open(outputdir + "/" + trainFileName + "_" + str(foldNumber) + ".data", 'wb')
        testFile = open(outputdir + "/" + testFileName + "_"  + str(foldNumber) + ".data", 'wb')
        

        partitionCounter = 1
        for document in documentList:
            if partitionCounter == foldNumber:
                testFile.write(document + '\n')
            else:
                trainFile.write(document + '\n')
            partitionCounter = partitionCounter + 1
            if partitionCounter > nrOfSplits:
                partitionCounter = 1
    trainFile.close()
    testFile.close()
    #for row in rowList:
     #   print row

#splitFilesInDir("testFilesAndScripts/splitTest", "testFilesAndScripts/testsplitdir", 10, "trainFiles", "testFiles")
#splitFile("splittest.data", "testsplitdir", 10, "hej", "hopp")



